(define-module (ordo action apt)
  #:use-module ((ordo connection) #:select (run)))

(define noninteractive-env '(("DEBIAN_FRONTEND" . "noninteractive")
                             ("APT_LISTCHANGES_FRONTEND" . "none")))

(define-syntax define-apt-operation
  (syntax-rules ()
    ((define-apt-operation (name args ...) apt-args ...)
     (define-public (name conn args ...)
       (run conn "apt-get" "-q" "-y" apt-args ... args ... #:env noninteractive-env)))
    ((define-apt-operation name apt-args ...)
     (define-public (name conn)
       (run conn "apt-get" "-q" "-y" apt-args ... #:env noninteractive-env)))))

(define-apt-operation apt:update "update")

(define-apt-operation apt:upgrade "upgrade")

(define-apt-operation apt:dist-upgrade "dist-upgrade")

(define-apt-operation (apt:install package-name) "install")

(define-apt-operation (apt:install-minimal package-name) "install" "--no-install-recommends")

(define-apt-operation (apt:reinstall package-name) "reinstall")

(define-apt-operation (apt:remove package-name) "remove")

(define-apt-operation (apt:purge package-name) "purge")

(define-apt-operation (apt:build-dep package-name) "build-dep")

(define-apt-operation apt:clean "clean")

(define-apt-operation apt:autoclean "autoclean")

(define-apt-operation apt:distclean "distclean")

(define-apt-operation apt:autoremove "autoremove")

(define-apt-operation apt:autopurge "autopurge")
