(define-module (ordo connection local)
  #:use-module (oop goops)
  #:use-module (ice-9 popen)
  #:use-module (ordo connection base)
  #:use-module (ordo util read-lines)
  #:export (<local-connection>))

(define-class <local-connection> (<connection>))

(define-method (conn:run (c <local-connection>) (command <string>))
  (let* ((port (open-input-pipe command))
         (output (read-lines port))
         (exit-status (status:exit-val (close-pipe port))))
    (values output exit-status)))

(define-method (conn:call-with-input-file (c <local-connection>) (filename <string>) (proc <procedure>))
  (call-with-input-file filename proc))

(define-method (conn:call-with-output-file (c <local-connection>) (filename <string>) (proc <procedure>))
  (call-with-output-file filename proc))
