(define-module (ordo interceptor connection)
  #:use-module (oop goops)
  #:use-module (ordo interceptor)
  #:use-module (ordo connection)
  #:use-module (ordo connection sudo)
  #:export (connection))

(define* (connection c #:key sudo? sudo-user sudo-password)
  "Interceptor to manage the current connection."
  (define (cleanup ctx)
    (and=> (context-connection ctx) conn:teardown)
    (set-context-connection! ctx #f))
  (interceptor
   "connection"
   #:enter (lambda (ctx)
             (let ((c (if sudo?
                          (make <sudo-connection> #:connection c #:become-user sudo-user #:become-password sudo-password)
                          c)))
               (conn:setup c)
               (set-context-connection! ctx c)))
   #:leave cleanup
   #:error cleanup))
