(define-module (ordo interceptor create-tmp-dir)
  #:use-module (srfi srfi-2)
  #:use-module (srfi srfi-145)
  #:use-module (ordo interceptor)
  #:use-module (ordo action filesystem)
  #:export (create-tmp-dir))

(define* (create-tmp-dir #:key (register 'tmp-dir))
  (assume (symbol? register) "register should be a symbol" register)
  (define (cleanup ctx)
    (and-let* ((tmp-dir (var-ref ctx register)))
      (fs:remove (context-connection ctx) tmp-dir #:recurse? #t)
      (var-delete! ctx register)))
  (interceptor
   (format #f "create-tmp-dir ~a" register)
   #:enter (lambda (ctx)
             (var-set! ctx register (fs:create-tmp-dir (context-connection ctx))))
   #:leave cleanup
   #:error cleanup))
