(define-module (ordo interceptor debug)
  #:use-module (ice-9 pretty-print)
  #:use-module ((srfi srfi-1) #:select (concatenate))
  #:use-module ((srfi srfi-69) #:select (hash-table-keys))
  #:use-module (ordo interceptor)
  #:export (debug-vars))

(define (debug-vars . var-names)
  (interceptor
   "debug-vars"
   #:enter (lambda (ctx)
             (let ((var-names (if (null? var-names)
                                  (hash-table-keys (context-vars ctx))
                                  var-names)))
               (pretty-print (map (lambda (v) (list v (var-ref ctx v 'not-found)))
                                  var-names))))))
