(define-module (ordo interceptor stat-file)
  #:use-module (srfi srfi-145)
  #:use-module (ordo interceptor)
  #:use-module (ordo action filesystem)
  #:export (stat-file))

(define* (stat-file name #:key path register)
  (assume (string? name) "name is required and should be a string" name)
  (assume path "path is required" path)
  (assume (or (not register) (symbol? register)) "register should be a symbol" register)
  (interceptor
   name
   #:enter (lambda (ctx)
             (let* ((path (expand-vars ctx path))
                    (st (fs:stat (context-connection ctx) path)))
               (when register
                 (var-set! ctx register st))))))
