(define-module (ordo logger)
  #:use-module (oop goops)
  #:use-module ((srfi srfi-1) #:select (take-while drop-while))
  #:use-module ((srfi srfi-26) #:select (cut))
  #:use-module (logging logger)
  #:use-module (logging port-log)
  #:export (setup-logging
            shutdown-logging))

(define log-levels '(TRACE DEBUG INFO NOTICE WARN ERROR))

(define* (setup-logging #:key (level 'INFO))
  (let ((logger (make <logger>))
        (handler (make <port-log> #:port (current-error-port))))
    (for-each (cut disable-log-level! handler <>)
              (take-while (negate (cut equal? level <>)) log-levels))
    (add-handler! logger handler)
    (set-default-logger! logger)
    (open-log! logger)))

(define (shutdown-logging)
  (flush-log)  ; since no args, it uses the default
  (close-log!) ; ditto
  (set-default-logger! #f))
