(define-module (ordo playbook)
  #:use-module (srfi srfi-9)
  #:use-module (srfi srfi-26)
  #:use-module (logging logger)
  #:use-module (ordo play)
  #:export (playbook
            playbook?
            playbook-name
            playbook-vars
            playbook-plays
            run-playbook))

(define-record-type <playbook>
  (make-playbook name vars plays)
  playbook?
  (name playbook-name)
  (vars playbook-vars)
  (plays playbook-plays))

(define* (playbook #:key name (vars '()) plays)
  (make-playbook name vars plays))

(define (run-playbook pb)
  (log-msg 'NOTICE "Running playbook: " (playbook-name pb))
  (for-each (cut run-play <> (playbook-vars pb))
            (playbook-plays pb)))
